# -*- coding: utf-8 -*-
###############################################################################~!!~~!!!
#
# Copyright (c) 2010-2012, OPENTIA Group (<http://opentia.com>)
# The word "OPENTIA" is an European Community Trademark property of the Opentia Group
#
# @author: Opentia "Happy Hacking" Team
# @e-mail: consultoria@opentia·es
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################~!!~~!!!
from osv import fields, osv
from tools.translate import _
import netsvc
import time


class stock_move(osv.osv):
    _inherit = "stock.move"
    _columns = {'pallet_type': fields.selection([('EUR','EUR'),('USA','USA'),('None','None')], 'Pallet'),}
    _defaults = {'pallet_type':lambda *a:'None'}

    # ¡ATENCIÓN! Este código modifica y sustituye la función equivalente de la tarea #507
    def action_done(self, cr, uid, ids, context=None):
        """ Makes the move done and if all moves are done, it will finish the picking.
        @return:
        """
        partial_datas=''
        picking_ids = []
        move_ids = []
        partial_obj=self.pool.get('stock.partial.picking')
        wf_service = netsvc.LocalService("workflow")
        partial_id=partial_obj.search(cr,uid,[])
        if partial_id: partial_datas = partial_obj.read(cr, uid, partial_id, context=context)[0]
        if context is None: context = {}
        todo = []
         
        for move in self.browse(cr, uid, ids, context=context):
            if move.state=="draft": todo.append(move.id)            
            # Actuaciones para evitar stocks negativos
            location_id = move.location_id.id
            product_id = move.product_id.id
            c = context.copy()
            c.update({'product_id':product_id})
            location = self.pool.get('stock.location').browse(cr,uid,location_id, context=c)
            product = self.pool.get('product.product').browse(cr,uid,product_id, context=c)
            if location.usage == 'internal': # and location.type not in ('na',''):
                if move.picking_id.sale_id != [] : stock_real = location.stock_real_available
                else: stock_real = location.stock_real
                qty = move.product_qty
                if stock_real < qty:
                    plural_qty = plural_real = ''
                    if qty<>1: plural_qty = _('s')
                    if stock_real<>1: plural_real = _('s')
                    if stock_real == 0: except_msg = _('because there are no available %s%s in %s') % (product.uom_id.name,plural_real, location.name)
                    else: except_msg = _('because there is only %.2f %s%s in %s') % (stock_real,product.uom_id.name,plural_real, location.name)
                    raise osv.except_osv(_('There are not enough units'), _('Cannot move %.2f %s%s of %s, %s.') % (qty, product.uom_id.name,plural_qty,product.name, except_msg))    
        if todo:
            self.action_confirm(cr, uid, todo, context=context)
            todo = []

        for move in self.browse(cr, uid, ids, context=context):
            if move.state in ['done','cancel']: continue
            move_ids.append(move.id)

            if move.picking_id: picking_ids.append(move.picking_id.id)
            if move.move_dest_id.id and (move.state != 'done'):
                self.write(cr, uid, [move.id], {'move_history_ids': [(4, move.move_dest_id.id)]})
                #cr.execute('insert into stock_move_history_ids (parent_id,child_id) values (%s,%s)', (move.id, move.move_dest_id.id))
                if move.move_dest_id.state in ('waiting', 'confirmed'):
                    if move.prodlot_id.id and move.product_id.id == move.move_dest_id.product_id.id:
                        self.write(cr, uid, [move.move_dest_id.id], {'prodlot_id':move.prodlot_id.id})
                    self.force_assign(cr, uid, [move.move_dest_id.id], context=context)
                    if move.move_dest_id.picking_id:
                        wf_service.trg_write(uid, 'stock.picking', move.move_dest_id.picking_id.id, cr)
                    if move.move_dest_id.auto_validate:
                        self.action_done(cr, uid, [move.move_dest_id.id], context=context)

            self._create_product_valuation_moves(cr, uid, move, context=context)
            prodlot_id = partial_datas and partial_datas.get('move%s_prodlot_id' % (move.id), False)
            if prodlot_id:
                self.write(cr, uid, [move.id], {'prodlot_id': prodlot_id}, context=context)
            if move.state not in ('confirmed','done','assigned'):
                todo.append(move.id)

        if todo:
            self.action_confirm(cr, uid, todo, context=context)
        self.write(cr, uid, move_ids, {'state': 'done', 'date': time.strftime('%Y-%m-%d %H:%M:%S')}, context=context)

        # Implementación extra para tarea #484
        for move in self.browse(cr, uid, move_ids, context=context):
            if move.location_dest_id.name ==  u'Pulmón Entrada':
                virtual_location_id = self.pool.get('stock.location').search(cr, uid, [('usage','=','virtual')], context=context)
                virtual_move_id = self.create(cr, uid, 
                    {
                        'name': 'VM:%s' % move.product_id.name,
                        'product_id' : move.product_id.id,
                        'prodlot_id' : move.prodlot_id.id,
                        'product_qty': move.product_qty,
                        'product_uom': move.product_uom.id,
                        'product_uos': move.product_uos.id,
                        'location_id': move.location_dest_id.id,
                        'location_dest_id': virtual_location_id[0],
                        'state': 'waiting',
                    }, context=context)

            elif move.location_dest_id.type == 'location':
                self.pool.get('stock.location').write(cr, uid, move.location_dest_id.id, {'rtaked':True, 'ltaked':True, 'pallet_type':move.pallet_type}, context=context)
                if move.pallet_type=='USA':
                    left_location_id = self.pool.get('stock.location').search(cr, uid, [('posy','=',move.location_dest_id.posy),
                        ('posz','=',move.location_dest_id.posz-1),('posr','=',move.location_dest_id.posr), ('posx','=',move.location_dest_id.posx),
                        ('type','=','location'),('rtaked','!=',True)])
                    right_location_id = self.pool.get('stock.location').search(cr, uid, [('posy','=',move.location_dest_id.posy),
                        ('posz','=',move.location_dest_id.posz+1),('posr','=',move.location_dest_id.posr), ('posx','=',move.location_dest_id.posx),
                        ('type','=','location'),('ltaked','!=',True)])
                    if (move.location_dest_id.posz) % 3 == 0: #Right column, (to fill left location)
                        if left_location_id!=[]: self.pool.get('stock.location').write(cr, uid, left_location_id, {'rtaked':True}, context=context)
                    elif (move.location_dest_id.posz+1) % 3 == 0: #Center column (shouldn't be filled)
                        if left_location_id!=[]: self.pool.get('stock.location').write(cr, uid, left_location_id, {'rtaked':True}, context=context)
                        elif right_location_id!=[]: self.pool.get('stock.location').write(cr, uid, right_location_id, {'ltaked':True}, context=context)                    
                    elif (move.location_dest_id.posz+2) % 3 == 0: #Left column, (to fill right location)
                        if right_location_id!=[]: self.pool.get('stock.location').write(cr, uid, right_location_id, {'ltaked':True}, context=context)
                if move.location_id.name ==  u'Pulmón Entrada':
                    virtual_move_ids = self.search(cr, uid, [('name','=','VM:%s' % move.product_id.name),('product_qty','=',move.product_qty),('prodlot_id','=',move.prodlot_id.id), ('state','=','draft')], context=context)
                    if virtual_move_ids!=[]: self.unlink(cr, uid, [virtual_move_ids[-1]], context=context)
            if move.location_id.type == 'location':
                c = context.copy()
                c.update({'product_id':move.product_id.id})
                location_product_obj = self.pool.get('stock.location').browse(cr, uid, move.location_id.id, context=c)
                if location_product_obj.stock_real == 0.0: #Location is empty
                    pallet_usa = False
                    if location_product_obj.pallet_type=='USA': pallet_usa = True
                    self.pool.get('stock.location').write(cr, uid, move.location_id.id, {'ltaked':False,'rtaked':False,'pallet_type': 'None'}, context=context)
                    if pallet_usa:
                        left_location_id = self.pool.get('stock.location').search(cr, uid, [('posy','=',move.location_id.posy),
                            ('posz','=',move.location_id.posz-1),('posr','=',move.location_id.posr), ('posx','=',move.location_id.posx),
                            ('type','=','location'),('rtaked','=',True)])
                        right_location_id = self.pool.get('stock.location').search(cr, uid, [('posy','=',move.location_id.posy),
                            ('posz','=',move.location_id.posz+1),('posr','=',move.location_id.posr), ('posx','=',move.location_id.posx),
                            ('type','=','location'),('ltaked','=',True)])
                        if (move.location_id.posz) % 3 == 0: #Right column, (empty left column)
                            if left_location_id!=[]: self.pool.get('stock.location').write(cr, uid, left_location_id, {'rtaked':False}, context=context)
                        elif (move.location_id.posz+1) % 3 == 0: #Center column
                            if left_location_id!=[]: self.pool.get('stock.location').write(cr, uid, left_location_id, {'rtaked':False}, context=context)
                            elif right_location_id!=[]: self.pool.get('stock.location').write(cr, uid, right_location_id, {'ltaked':False}, context=context)                    
                        elif (move.location_id.posz+2) % 3 == 0: #Left column, (empty right location)
                            if right_location_id!=[]: self.pool.get('stock.location').write(cr, uid, right_location_id, {'ltaked':False}, context=context)

        for id in move_ids: wf_service.trg_trigger(uid, 'stock.move', id, cr)
        for pick_id in picking_ids: wf_service.trg_write(uid, 'stock.picking', pick_id, cr)

        return True

    def action_cancel(self, cr, uid, ids, context=None):
        """ Cancels the moves and if all moves are cancelled it cancels the picking.
        @return: True
        """
        if not len(ids):
            return True
        if context is None:
            context = {}
        pickings = {}
        picking_obj = self.pool.get('stock.picking')
        for move in self.browse(cr, uid, ids, context=context):
            if move.state in ('confirmed', 'waiting', 'assigned', 'draft'):
                if move.picking_id:
                    pickings[move.picking_id.id] = True
            if move.move_dest_id and move.move_dest_id.state == 'waiting':
                self.write(cr, uid, [move.move_dest_id.id], {'state': 'confirmed'})
                if context.get('call_unlink',False) and move.move_dest_id.picking_id:
                    wf_service = netsvc.LocalService("workflow")
                    wf_service.trg_write(uid, 'stock.picking', move.move_dest_id.picking_id.id, cr)
            if move.location_id.name ==  u'Pulmón Entrada':
                virtual_move_ids = self.search(cr, uid, [('name','=','VM:%s' % move.product_id.name),('product_qty','=',move.product_qty),('prodlot_id','=',move.prodlot_id.id), ('state','=','draft')], context=context)
                if virtual_move_ids!=[]: self.write(cr, uid, virtual_move_ids[-1], {'state':'waiting'}, context=context)
        self.write(cr, uid, ids, {'state': 'cancel', 'move_dest_id': False})
        if not context.get('call_unlink',False):
            for pick in picking_obj.browse(cr, uid, pickings.keys()):
                if all(move.state == 'cancel' for move in pick.move_lines):
                    picking_obj.write(cr, uid, [pick.id], {'state': 'cancel'})

        wf_service = netsvc.LocalService("workflow")
        for id in ids:
            wf_service.trg_trigger(uid, 'stock.move', id, cr)
        return True

stock_move()

class stock_location(osv.osv):
    #Atención: posr tiene el mismo sentido funcional que el campo posxs del módulo opentia_mediapost
    #          pospy ya no nos hace falta al controlar todas las alturas por posy
    #          pospz tiene el mismo sentido funcional que el campo posr del módulo opentia_mediapost 
    _inherit = "stock.location"
    _columns = {
        'posx' : fields.integer('Corridor',help="Localization details"),
        'posr' : fields.integer('Shelves', help="Localization details"),
        'posy' : fields.integer('Height', help="Localization details"),
        'posz' : fields.integer('Depth', help="Localization details"),
        'pospz': fields.char('Picking Depth', help="Picking localization details", size=1),
        'pospy': fields.integer('Picking Height', help="Picking localization details"),
        'ltaked':fields.boolean('Left taked' , help='The left side of this location is occupied'),
        'rtaked':fields.boolean('Right Taked',help='The right side of this location is occupied'),
        'pallet_type':fields.selection([('EUR','EUR'),('USA','USA'),('None','None')], 'Pallet', help=''),
        'usage': fields.selection([('supplier', 'Supplier Location'), ('view', 'View'), ('internal', 'Internal Location'), ('customer', 'Customer Location'),
                                ('inventory', 'Inventory'), ('procurement', 'Procurement'), ('production', 'Production'),
                                ('transit', 'Transit Location for Inter-Companies Transfers'), ('virtual','Virtual')], 'Location Type', required=True,
                 help="""* Supplier Location: Virtual location representing the source location for products coming from your suppliers
                       \n* View: Virtual location used to create a hierarchical structures for your warehouse, aggregating its child locations ; can't directly contain products
                       \n* Internal Location: Physical locations inside your own warehouses,
                       \n* Customer Location: Virtual location representing the destination location for products sent to your customers
                       \n* Inventory: Virtual location serving as counterpart for inventory operations used to correct stock levels (Physical inventories)
                       \n* Procurement: Virtual location serving as temporary counterpart for procurement operations when the source (supplier or production) is not known yet. This location should be empty when the procurement scheduler has finished running.
                       \n* Production: Virtual counterpart location for production operations: this location consumes the raw material and produces finished products
                       \n* Virtual: Virtual stock location
                      """, select = True),
    }
    
    _defaults = {'ltaked': lambda *a: False, 'rtaked': lambda *a: False}

    def onchange_location_id(self, cr, uid, ids, parent_location):
        location_obj = self.pool.get('stock.location').browse(cr, uid, parent_location)
        v = {}
        v.update({
            'posx':location_obj.posx, 'posr':location_obj.posr, 'posy':location_obj.posy, 'posz':location_obj.posz, 
            'partner_id': location_obj.partner_id.id, 'exclusive_product_id': location_obj.exclusive_product_id.id,
        })
        return {'value': v}

    def location_available(self, cr, uid, ids, location, context):
        # *location is a browse record
        pallet_usa = False
        is_available = True
        if context.has_key('pallet_type'):
            if context.get('pallet_type') == 'USA': pallet_usa = True
        c = context.copy()
        if location.blocked or location.stock_real > 0 or location.ltaked or location.rtaked: is_available=False
        elif pallet_usa:
            left_location_id = self.search(cr, uid, [('posy','=',location.posy), ('posz','=',location.posz-1), ('posr','=',location.posr), ('posx','=',location.posx),
                    ('blocked','!=',True), ('type','=','location'), ('id','!=',context.get('origin_location_id')), ('rtaked','!=',True)])
            right_location_id = self.search(cr, uid, [('posy','=',location.posy), ('posz','=',location.posz+1), ('posr','=',location.posr), ('posx','=',location.posx),
                    ('blocked','!=',True), ('type','=','location'), ('id','!=',context.get('origin_location_id')), ('ltaked','!=',True)])
            if (location.posz) % 3 == 0: #Right column, check left
                if left_location_id==[]: is_available=False                        
                elif self.browse(cr,uid,left_location_id,context=c)[0].stock_real >0: is_available=False
            elif (location.posz+1) % 3 == 0: is_available=False #Center column
            elif (location.posz+2) % 3 == 0: #Left column, check right
                if right_location_id==[]: is_available=False
                elif self.browse(cr,uid,right_location_id,context=c)[0].stock_real >0: is_available=False
        return is_available

    def search_height_location(self, cr, uid, ids, context):
        posy_init = 4 # height starts in 4
        posy = posy_init
        jumpz = 0
        iteration = 1
        checked_locations =[]
        if context.has_key('checked_locations'): checked_locations=context.get('checked_locations')
        if context.has_key('iteration'): iteration=context.get('iteration')
        if context.has_key('jumpz'): jumpz=context.get('jumpz')
        if context.has_key('posy'): posy=context.get('posy')
        if posy>7+posy_init: return 0 #Max height to check
        c = context.copy()
        for location in self.browse(cr, uid, context.get('origin_ids'), context):
            h_location_id = self.search(cr, uid, [('posy','=',posy), ('posz','=',location.posz), ('posr','=',location.posr), ('posx','=',location.posx)])
            if h_location_id != []:
                if h_location_id[0] not in checked_locations:
                    h_location_obj = self.browse(cr, uid, h_location_id[0], context=c)
                    if self.location_available(cr, uid, ids, h_location_obj, context=c): return h_location_obj.id
                    checked_locations.append(h_location_obj.id)
                    c.update({'checked_locations':checked_locations})
                else:
                    posz=location.posz - jumpz
                    h_location_id = self.search(cr, uid, [('posy','=',posy), ('posz','=',posz), ('posr','=',location.posr), ('posx','=',location.posx)])
                    if h_location_id!=[] and h_location_id[0] not in checked_locations:
                        h_location_obj = self.browse(cr, uid, h_location_id[0], context=c)
                        if self.location_available(cr, uid, ids, h_location_obj, context=c): return h_location_obj.id
                        checked_locations.append(h_location_obj.id)
                        c.update({'checked_locations':checked_locations})
                    posz=location.posz + jumpz
                    h_location_id = self.search(cr, uid, [('posy','=',posy), ('posz','=',posz), ('posr','=',location.posr), ('posx','=',location.posx)])
                    if h_location_id!=[] and h_location_id[0] not in checked_locations:
                        h_location_obj = self.browse(cr, uid, h_location_id[0], context=c)
                        if self.location_available(cr, uid, ids, h_location_obj, context=c): return h_location_obj.id
                        checked_locations.append(h_location_obj.id)
                        c.update({'checked_locations':checked_locations})
            if iteration < 4 : c.update({'posy':posy+1})
            if iteration == 3: c.update({'posy':posy_init+1,'jumpz':1})
            elif iteration == 4: c.update({'posy':posy_init+2,'jumpz':1})
            elif iteration == 5: c.update({'posy':posy_init+2,'jumpz':2})
            elif iteration >5:
                if (iteration+2) % 4 == 0: c.update({'posy':posy+1,'jumpz':0})
                elif (iteration+1) % 4==0: c.update({'posy':posy,'jumpz':posy-(2+posy_init)})
                elif (iteration % 4) == 0: c.update({'posy':posy,'jumpz':posy-(1+posy_init)})
                elif (iteration-1) % 4==0: c.update({'posy':posy,'jumpz':posy-posy_init})
        c.update({'iteration':iteration+1})
        return self.search_height_location(cr, uid, ids, context=c)
        return 0

    def inlung2stock(self, cr, uid, ids, context=None):
        if context==None: context = {}
        if not context.has_key('product_id'): raise osv.except_osv('Internal Error!','No product specified')
        picking_ids = self.search(cr, uid, [('exclusive_product_id','=',context.get('product_id'))], order='posx asc, posr asc, posz asc')
        c = context.copy()
        dest_location_id = 0
        if picking_ids!=[]:
            c.update({'origin_ids': picking_ids})
            dest_location_id = self.search_height_location(cr, uid, ids, context=c)
        else:
            raise osv.except_osv(_('Error!'),_('The product has no assigned location.')) #Stop line for tests
        if dest_location_id == 0: raise osv.except_osv(_('Can not place products'),_('No locations availables.'))
        destino_obj = self.browse(cr, uid , dest_location_id)
        picking_id = self.pool.get('stock.picking').create(cr, uid, {
                    'origin': 'Auto',
                    'type': 'internal',
                    'move_type': 'one',
                    'state': 'draft',
                    'invoice_state': 'none',
                    'auto_picking': False,
                    'date': time.strftime('%Y-%m-%d %H:%M:%S'),
                    'min_date': time.strftime('%Y-%m-%d %H:%M:%S'),
                    })
        product_obj = self.pool.get('product.product').browse(cr, uid, context.get('product_id'))
        if product_obj.default_code: p_name = '[%s] %s' % (product_obj.default_code, product_obj.name)
        else: p_name = product_obj.name
        move_id = self.pool.get('stock.move').create(cr, uid, 
                    {
                        'name': p_name,
                        'picking_id' : picking_id,
                        'product_id' : product_obj.id,
                        'prodlot_id' : context.get('prodlot_id'),
                        'product_qty': context.get('product_qty'),
                        'pallet_type': context.get('pallet_type'),
                        'product_uom': context.get('product_uom'),
                        'product_uos': context.get('product_uos'),
                        'product_packaging': context.get('product_packaging'),
                        'tracking_id': context.get('tracking_id'),
                        'location_id': context.get('location_id'),
                        'location_dest_id': dest_location_id,
                        'date': context.get('date'),
                        'date_expected':context.get('date_expected'),
                        'state': 'draft',
                        'scrapped' :  False,
                    })
        confirm = self.pool.get('stock.picking').draft_validate(cr, uid, [picking_id])

        virtual_move_ids = self.pool.get('stock.move').search(cr, uid, [
            ('name','=','VM:%s' % product_obj.name),('product_qty','=',context.get('product_qty')),('prodlot_id','=',context.get('prodlot_id')),('state','=','waiting')
            ], context=context)
        if virtual_move_ids !=[]: self.pool.get('stock.move').write(cr, uid, virtual_move_ids[-1], {'state':'draft'}, context=context)

        return picking_id

stock_location()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
